//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:2.0.50727.1433
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using Microsoft.Ccr.Core;
using Microsoft.Dss.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Xml.Serialization;
using W3C.Soap;
using compression = System.IO.Compression;
using constructor = Microsoft.Dss.Services.Constructor;
using contractmanager = Microsoft.Dss.Services.ContractManager;
using contractmodel = Microsoft.Dss.Services.ContractModel;
using dssphttp = Microsoft.Dss.Core.DsspHttp;
using io = System.IO;
using pxbasicstamp2 = Microsoft.Robotics.Services.BasicStamp2.Proxy;
using reflection = System.Reflection;


namespace Microsoft.Robotics.Services.BasicStamp2.Proxy
{
    
    
    /// <summary>
    /// BasicStamp2 Contract
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public sealed class Contract
    {
        
        /// The Unique Contract Identifier for the BasicStamp2 service
        public const String Identifier = "http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html";
        
        /// The Dss Service dssModel Contract(s)
        public static List<contractmodel.ServiceSummary> ServiceModel()
        {
            contractmanager.ServiceSummaryLoader loader = new contractmanager.ServiceSummaryLoader();
            return loader.GetServiceSummaries(typeof(Contract).Assembly);

        }
        
        /// <summary>
        /// Creates an instance of the service associated with this contract
        /// </summary>
        /// <param name="contructorServicePort">Contractor Service that will create the instance</param>
        /// <param name="partners">Optional list of service partners for new service instance</param>
        /// <returns>Result PortSet for retrieving service creation response</returns>
        public static DsspResponsePort<CreateResponse> CreateService(constructor.ConstructorPort contructorServicePort, params PartnerType[] partners)
        {
            DsspResponsePort<CreateResponse> result = new DsspResponsePort<CreateResponse>();
            ServiceInfoType si = new ServiceInfoType(Contract.Identifier, null);
            if (partners != null)
            {
                si.PartnerList = new List<PartnerType>(partners);
            }
            Microsoft.Dss.Services.Constructor.Create create =
                new Microsoft.Dss.Services.Constructor.Create(si, result);
            contructorServicePort.Post(create);
            return result;

        }
        
        /// <summary>
        /// Creates an instance of the service associated with this contract
        /// </summary>
        /// <param name="contructorServicePort">Contractor Service that will create the instance</param>
        /// <returns>Result PortSet for retrieving service creation response</returns>
        public static DsspResponsePort<CreateResponse> CreateService(constructor.ConstructorPort contructorServicePort)
        {
            return Contract.CreateService(contructorServicePort, null);
        }
    }
    
    /// <summary>
    /// The BASIC Stamp 's configuration state.
    /// </summary>
    [Description("The BASIC Stamp\'s configuration state.")]
    [DataContract()]
    [XmlRootAttribute("BasicStampState", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class BasicStampState : ICloneable, IDssSerializable
    {
        
        private Config _configuration;
        
        private Boolean _autonomousMode;
        
        private Boolean _connected;
        
        private Int32 _frameCounter;
        
        private Int32 _connectAttempts;
        
        private MotorSpeed _motorSpeed;
        
        private Sensors _sensors;
        
        /// <summary>
        /// Configuration
        /// </summary>
        [DataMember()]
        [Description("Configuration details.")]
        public Config Configuration
        {
            get
            {
                return this._configuration;
            }
            set
            {
                this._configuration = value;
            }
        }
        
        /// <summary>
        /// Autonomous Mode
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Specifies if the BASIC Stamp is in autonomous mode or if it is controlled by the " +
            "PC.")]
        public Boolean AutonomousMode
        {
            get
            {
                return this._autonomousMode;
            }
            set
            {
                this._autonomousMode = value;
            }
        }
        
        /// <summary>
        /// Connected
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Specifies if the BASIC Stamp is currently connected.")]
        public Boolean Connected
        {
            get
            {
                return this._connected;
            }
            set
            {
                this._connected = value;
            }
        }
        
        /// <summary>
        /// Frame Counter
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Specifies the current frame count.")]
        public Int32 FrameCounter
        {
            get
            {
                return this._frameCounter;
            }
            set
            {
                this._frameCounter = value;
            }
        }
        
        /// <summary>
        /// Connect Attempts
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Specifies how many connection attempts were made.")]
        public Int32 ConnectAttempts
        {
            get
            {
                return this._connectAttempts;
            }
            set
            {
                this._connectAttempts = value;
            }
        }
        
        /// <summary>
        /// Motor Speed
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Specifies the current motor speed setting.")]
        public MotorSpeed MotorSpeed
        {
            get
            {
                return this._motorSpeed;
            }
            set
            {
                this._motorSpeed = value;
            }
        }
        
        /// <summary>
        /// Sensors
        /// </summary>
        [DataMember()]
        [Browsable(false)]
        [Description("Specifies the state of the BASIC Stamp\'s set of sensors.")]
        public Sensors Sensors
        {
            get
            {
                return this._sensors;
            }
            set
            {
                this._sensors = value;
            }
        }
        
        /// <summary>
        /// Copy To Basic Stamp State
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            BasicStampState typedTarget = target as BasicStampState;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Configuration = (this.Configuration == null) ? null : (Config)((Microsoft.Dss.Core.IDssSerializable)this.Configuration).Clone();
            typedTarget.AutonomousMode = this.AutonomousMode;
            typedTarget.Connected = this.Connected;
            typedTarget.FrameCounter = this.FrameCounter;
            typedTarget.ConnectAttempts = this.ConnectAttempts;
            typedTarget.MotorSpeed = (this.MotorSpeed == null) ? null : (MotorSpeed)((Microsoft.Dss.Core.IDssSerializable)this.MotorSpeed).Clone();
            typedTarget.Sensors = (this.Sensors == null) ? null : (Sensors)((Microsoft.Dss.Core.IDssSerializable)this.Sensors).Clone();
        }
        
        /// <summary>
        /// Clone Basic Stamp State
        /// </summary>
        public virtual object Clone()
        {
            BasicStampState target = new BasicStampState();

            target.Configuration = (this.Configuration == null) ? null : (Config)((Microsoft.Dss.Core.IDssSerializable)this.Configuration).Clone();
            target.AutonomousMode = this.AutonomousMode;
            target.Connected = this.Connected;
            target.FrameCounter = this.FrameCounter;
            target.ConnectAttempts = this.ConnectAttempts;
            target.MotorSpeed = (this.MotorSpeed == null) ? null : (MotorSpeed)((Microsoft.Dss.Core.IDssSerializable)this.MotorSpeed).Clone();
            target.Sensors = (this.Sensors == null) ? null : (Sensors)((Microsoft.Dss.Core.IDssSerializable)this.Sensors).Clone();
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (Configuration == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)Configuration).Serialize(writer);
            }

            writer.Write(AutonomousMode);

            writer.Write(Connected);

            writer.Write(FrameCounter);

            writer.Write(ConnectAttempts);

            if (MotorSpeed == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)MotorSpeed).Serialize(writer);
            }

            if (Sensors == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                ((Microsoft.Dss.Core.IDssSerializable)Sensors).Serialize(writer);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                Configuration = (Config)((Microsoft.Dss.Core.IDssSerializable)new Config()).Deserialize(reader);
            } //nullable

            AutonomousMode = reader.ReadBoolean();

            Connected = reader.ReadBoolean();

            FrameCounter = reader.ReadInt32();

            ConnectAttempts = reader.ReadInt32();

            if (reader.ReadByte() == 0) {}
            else
            {
                MotorSpeed = (MotorSpeed)((Microsoft.Dss.Core.IDssSerializable)new MotorSpeed()).Deserialize(reader);
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                Sensors = (Sensors)((Microsoft.Dss.Core.IDssSerializable)new Sensors()).Deserialize(reader);
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// The BASIC Stamp 's low level configuration parameters.
    /// </summary>
    [Description("The BASIC Stamp\'s low level configuration parameters.")]
    [DataContract()]
    [XmlRootAttribute("Config", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class Config : ICloneable, IDssSerializable
    {
        
        private Int32 _delay;
        
        private Int32 _serialPort;
        
        /// <summary>
        /// Delay
        /// </summary>
        [DataMember()]
        [Description("Specifies the delay (in ms) for accessing the serial port.")]
        public Int32 Delay
        {
            get
            {
                return this._delay;
            }
            set
            {
                this._delay = value;
            }
        }
        
        /// <summary>
        /// Serial Port
        /// </summary>
        [DataMember()]
        [Description("Specifies the serial port number used for connecting to the BASIC Stamp.")]
        public Int32 SerialPort
        {
            get
            {
                return this._serialPort;
            }
            set
            {
                this._serialPort = value;
            }
        }
        
        /// <summary>
        /// Copy To Config
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Config typedTarget = target as Config;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Delay = this.Delay;
            typedTarget.SerialPort = this.SerialPort;
        }
        
        /// <summary>
        /// Clone Config
        /// </summary>
        public virtual object Clone()
        {
            Config target = new Config();

            target.Delay = this.Delay;
            target.SerialPort = this.SerialPort;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(Delay);

            writer.Write(SerialPort);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            Delay = reader.ReadInt32();

            SerialPort = reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// Specifies the state of the BASIC Stamp 's set of sensors.
    /// </summary>
    [Description("Specifies the state of the BASIC Stamp\'s set of sensors.")]
    [DataContract()]
    [XmlRootAttribute("Sensors", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class Sensors : ICloneable, IDssSerializable
    {
        
        private Boolean _iRLeft;
        
        private Boolean _iRRight;
        
        private Boolean _whiskerLeft;
        
        private Boolean _whiskerRight;
        
        /// <summary>
        /// Specifies the state of the BASIC Stamp 's set of sensors.
        /// </summary>
        public Sensors()
        {
        }
        
        /// <summary>
        /// Specifies the state of the BASIC Stamp 's set of sensors.
        /// </summary>
        public Sensors(bool iRLeft, bool iRRight, bool whiskerLeft, bool whiskerRight)
        {
            this._iRLeft = iRLeft;
            this._iRRight = iRRight;
            this._whiskerLeft = whiskerLeft;
            this._whiskerRight = whiskerRight;
        }
        
        /// <summary>
        /// IR Left
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=1)]
        [Browsable(false)]
        [Description("Identifies the left IR sensor\'s value.")]
        public Boolean IRLeft
        {
            get
            {
                return this._iRLeft;
            }
            set
            {
                this._iRLeft = value;
            }
        }
        
        /// <summary>
        /// IR Right
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=2)]
        [Browsable(false)]
        [Description("Identifies the right IR sensor\'s value.")]
        public Boolean IRRight
        {
            get
            {
                return this._iRRight;
            }
            set
            {
                this._iRRight = value;
            }
        }
        
        /// <summary>
        /// Whisker Left
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=3)]
        [Browsable(false)]
        [Description("Identifies the left whisker\'s value.")]
        public Boolean WhiskerLeft
        {
            get
            {
                return this._whiskerLeft;
            }
            set
            {
                this._whiskerLeft = value;
            }
        }
        
        /// <summary>
        /// Whisker Right
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=4)]
        [Browsable(false)]
        [Description("Identifies the right whisker\'s value.")]
        public Boolean WhiskerRight
        {
            get
            {
                return this._whiskerRight;
            }
            set
            {
                this._whiskerRight = value;
            }
        }
        
        /// <summary>
        /// Copy To Sensors
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Sensors typedTarget = target as Sensors;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.IRLeft = this.IRLeft;
            typedTarget.IRRight = this.IRRight;
            typedTarget.WhiskerLeft = this.WhiskerLeft;
            typedTarget.WhiskerRight = this.WhiskerRight;
        }
        
        /// <summary>
        /// Clone Sensors
        /// </summary>
        public virtual object Clone()
        {
            Sensors target = new Sensors();

            target.IRLeft = this.IRLeft;
            target.IRRight = this.IRRight;
            target.WhiskerLeft = this.WhiskerLeft;
            target.WhiskerRight = this.WhiskerRight;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(IRLeft);

            writer.Write(IRRight);

            writer.Write(WhiskerLeft);

            writer.Write(WhiskerRight);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            IRLeft = reader.ReadBoolean();

            IRRight = reader.ReadBoolean();

            WhiskerLeft = reader.ReadBoolean();

            WhiskerRight = reader.ReadBoolean();

            return this;

        }
    }
    
    /// <summary>
    /// Specifies the current left and right motor speed.
    /// </summary>
    [Description("Specifies the current left and right motor speed.")]
    [DataContract()]
    [XmlRootAttribute("MotorSpeed", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class MotorSpeed : ICloneable, IDssSerializable
    {
        
        private Nullable<System.Double> _leftSpeed;
        
        private Nullable<System.Double> _rightSpeed;
        
        /// <summary>
        /// Specifies the current left and right motor speed.
        /// </summary>
        public MotorSpeed()
        {
        }
        
        /// <summary>
        /// Specifies the current left and right motor speed.
        /// </summary>
        public MotorSpeed(System.Nullable<System.Double> leftSpeed, System.Nullable<System.Double> rightSpeed)
        {
            this._leftSpeed = leftSpeed;
            this._rightSpeed = rightSpeed;
        }
        
        /// <summary>
        /// Left Speed
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=1)]
        [Browsable(false)]
        [Description("Identifies the left motor\'s speed setting.")]
        public Nullable<System.Double> LeftSpeed
        {
            get
            {
                return this._leftSpeed;
            }
            set
            {
                this._leftSpeed = value;
            }
        }
        
        /// <summary>
        /// Right Speed
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=2)]
        [Browsable(false)]
        [Description("Identifies the right motor\'s speed setting.")]
        public Nullable<System.Double> RightSpeed
        {
            get
            {
                return this._rightSpeed;
            }
            set
            {
                this._rightSpeed = value;
            }
        }
        
        /// <summary>
        /// Copy To Motor Speed
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            MotorSpeed typedTarget = target as MotorSpeed;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.LeftSpeed = this.LeftSpeed;
            typedTarget.RightSpeed = this.RightSpeed;
        }
        
        /// <summary>
        /// Clone Motor Speed
        /// </summary>
        public virtual object Clone()
        {
            MotorSpeed target = new MotorSpeed();

            target.LeftSpeed = this.LeftSpeed;
            target.RightSpeed = this.RightSpeed;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            if (LeftSpeed == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(LeftSpeed.Value);
            }

            if (RightSpeed == null) writer.Write((byte)0);
            else
            {
                // null flag
                writer.Write((byte)1);

                writer.Write(RightSpeed.Value);
            }

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            if (reader.ReadByte() == 0) {}
            else
            {
                LeftSpeed = reader.ReadDouble();
            } //nullable

            if (reader.ReadByte() == 0) {}
            else
            {
                RightSpeed = reader.ReadDouble();
            } //nullable

            return this;

        }
    }
    
    /// <summary>
    /// Specifies if the BASIC Stamp is in autonomous mode or if it is controlled by the PC.
    /// </summary>
    [Description("Specifies if the BASIC Stamp is in autonomous mode or if it is controlled by the " +
        "PC.")]
    [DataContract()]
    [XmlRootAttribute("AutonomousMode", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class AutonomousMode : ICloneable, IDssSerializable
    {
        
        private Boolean _mode;
        
        /// <summary>
        /// Mode
        /// </summary>
        [DataMember()]
        [Description("Identifies the current operational mode (true = autonomous mode).")]
        public Boolean Mode
        {
            get
            {
                return this._mode;
            }
            set
            {
                this._mode = value;
            }
        }
        
        /// <summary>
        /// Copy To Autonomous Mode
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            AutonomousMode typedTarget = target as AutonomousMode;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Mode = this.Mode;
        }
        
        /// <summary>
        /// Clone Autonomous Mode
        /// </summary>
        public virtual object Clone()
        {
            AutonomousMode target = new AutonomousMode();

            target.Mode = this.Mode;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(Mode);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            Mode = reader.ReadBoolean();

            return this;

        }
    }
    
    /// <summary>
    /// Specifies settings for up to two I/O pins.
    /// </summary>
    [Description("Specifies settings for up to two I/O pins.")]
    [DataContract()]
    [XmlRootAttribute("Pins", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class Pins : ICloneable, IDssSerializable
    {
        
        private Byte _pin1;
        
        private Byte _op1;
        
        private Byte _pin2;
        
        private Byte _op2;
        
        /// <summary>
        /// Specifies settings for up to two I/O pins.
        /// </summary>
        public Pins()
        {
        }
        
        /// <summary>
        /// Specifies settings for up to two I/O pins.
        /// </summary>
        public Pins(byte pin1, byte op1, byte pin2, byte op2)
        {
            this._pin1 = pin1;
            this._op1 = op1;
            this._pin2 = pin2;
            this._op2 = op2;
        }
        
        /// <summary>
        /// Pin1
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=1)]
        [Description("Number of the first pin.")]
        public Byte Pin1
        {
            get
            {
                return this._pin1;
            }
            set
            {
                this._pin1 = value;
            }
        }
        
        /// <summary>
        /// Op1
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=2)]
        [Description("Operation for first pin.")]
        public Byte Op1
        {
            get
            {
                return this._op1;
            }
            set
            {
                this._op1 = value;
            }
        }
        
        /// <summary>
        /// Pin2
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=3)]
        [Description("Number of the second pin.")]
        public Byte Pin2
        {
            get
            {
                return this._pin2;
            }
            set
            {
                this._pin2 = value;
            }
        }
        
        /// <summary>
        /// Op2
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=4)]
        [Description("Operation for second pin.")]
        public Byte Op2
        {
            get
            {
                return this._op2;
            }
            set
            {
                this._op2 = value;
            }
        }
        
        /// <summary>
        /// Copy To Pins
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Pins typedTarget = target as Pins;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Pin1 = this.Pin1;
            typedTarget.Op1 = this.Op1;
            typedTarget.Pin2 = this.Pin2;
            typedTarget.Op2 = this.Op2;
        }
        
        /// <summary>
        /// Clone Pins
        /// </summary>
        public virtual object Clone()
        {
            Pins target = new Pins();

            target.Pin1 = this.Pin1;
            target.Op1 = this.Op1;
            target.Pin2 = this.Pin2;
            target.Op2 = this.Op2;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(Pin1);

            writer.Write(Op1);

            writer.Write(Pin2);

            writer.Write(Op2);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            Pin1 = reader.ReadByte();

            Op1 = reader.ReadByte();

            Pin2 = reader.ReadByte();

            Op2 = reader.ReadByte();

            return this;

        }
    }
    
    /// <summary>
    /// Sound a Tone on the Speaker.
    /// </summary>
    [Description("Sound a Tone on the Speaker.")]
    [DataContract()]
    [XmlRootAttribute("Tone", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class Tone : ICloneable, IDssSerializable
    {
        
        private Int32 _frequency;
        
        private Int32 _duration;
        
        /// <summary>
        /// Sound a Tone on the Speaker.
        /// </summary>
        public Tone()
        {
        }
        
        /// <summary>
        /// Sound a Tone on the Speaker.
        /// </summary>
        public Tone(int frequency, int duration)
        {
            this._frequency = frequency;
            this._duration = duration;
        }
        
        /// <summary>
        /// Frequency
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=1)]
        [Description("Frequency in Hz (rounded to nearest 50Hz).")]
        public Int32 Frequency
        {
            get
            {
                return this._frequency;
            }
            set
            {
                this._frequency = value;
            }
        }
        
        /// <summary>
        /// Duration
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=2)]
        [Description("Duration in Milliseconds (rounded to nearest 50ms).")]
        public Int32 Duration
        {
            get
            {
                return this._duration;
            }
            set
            {
                this._duration = value;
            }
        }
        
        /// <summary>
        /// Copy To Tone
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Tone typedTarget = target as Tone;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Frequency = this.Frequency;
            typedTarget.Duration = this.Duration;
        }
        
        /// <summary>
        /// Clone Tone
        /// </summary>
        public virtual object Clone()
        {
            Tone target = new Tone();

            target.Frequency = this.Frequency;
            target.Duration = this.Duration;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(Frequency);

            writer.Write(Duration);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            Frequency = reader.ReadInt32();

            Duration = reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// Execute pre -defined Behavior (in firmware).
    /// </summary>
    [Description("Execute pre-defined Behavior (in firmware).")]
    [DataContract()]
    [XmlRootAttribute("Behavior", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public class Behavior : ICloneable, IDssSerializable
    {
        
        private Char _code;
        
        private Int32 _duration;
        
        /// <summary>
        /// Execute pre -defined Behavior (in firmware).
        /// </summary>
        public Behavior()
        {
        }
        
        /// <summary>
        /// Execute pre -defined Behavior (in firmware).
        /// </summary>
        public Behavior(char code, int duration)
        {
            this._code = code;
            this._duration = duration;
        }
        
        /// <summary>
        /// Code
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=1)]
        [Browsable(false)]
        [Description("Code (single character code for the Behavior).")]
        public Char Code
        {
            get
            {
                return this._code;
            }
            set
            {
                this._code = value;
            }
        }
        
        /// <summary>
        /// Duration
        /// </summary>
        [DataMember()]
        [DataMemberConstructorAttribute(Order=2)]
        [Browsable(false)]
        [Description("Duration counter (multiple of 23ms).")]
        public Int32 Duration
        {
            get
            {
                return this._duration;
            }
            set
            {
                this._duration = value;
            }
        }
        
        /// <summary>
        /// Copy To Behavior
        /// </summary>
        public virtual void CopyTo(IDssSerializable target)
        {
            Behavior typedTarget = target as Behavior;

            if (typedTarget == null)
                throw new ArgumentException("CopyTo({0}) requires type {0}", this.GetType().FullName);
            typedTarget.Code = this.Code;
            typedTarget.Duration = this.Duration;
        }
        
        /// <summary>
        /// Clone Behavior
        /// </summary>
        public virtual object Clone()
        {
            Behavior target = new Behavior();

            target.Code = this.Code;
            target.Duration = this.Duration;
            return target;

        }
        
        /// <summary>
        /// Serialize Serialize
        /// </summary>
        public virtual void Serialize(System.IO.BinaryWriter writer)
        {
            writer.Write(Code);

            writer.Write(Duration);

        }
        
        /// <summary>
        /// Deserialize Deserialize
        /// </summary>
        public virtual object Deserialize(System.IO.BinaryReader reader)
        {
            Code = reader.ReadChar();

            Duration = reader.ReadInt32();

            return this;

        }
    }
    
    /// <summary>
    /// Pin Operations
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("PinOperations", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public enum PinOperations
    {
        
        /// <summary>
        /// NO_OP
        /// </summary>
        NO_OP = 0,
        
        /// <summary>
        /// SET_OUTPUT
        /// </summary>
        SET_OUTPUT = 1,
        
        /// <summary>
        /// SET_INPUT
        /// </summary>
        SET_INPUT = 2,
        
        /// <summary>
        /// OUTPUT_HIGH
        /// </summary>
        OUTPUT_HIGH = 3,
        
        /// <summary>
        /// OUTPUT_LOW
        /// </summary>
        OUTPUT_LOW = 4,
    }
    
    /// <summary>
    /// Behaviors
    /// </summary>
    [DataContract()]
    [XmlRootAttribute("Behaviors", Namespace="http://schemas.microsoft.com/robotics/2007/06/basicstamp2.html")]
    public enum Behaviors
    {
        
        /// <summary>
        /// U_TURN
        /// </summary>
        U_TURN = 85,
        
        /// <summary>
        /// LEFT_TURN
        /// </summary>
        LEFT_TURN = 76,
        
        /// <summary>
        /// RIGHT_TURN
        /// </summary>
        RIGHT_TURN = 82,
        
        /// <summary>
        /// FORWARD
        /// </summary>
        FORWARD = 70,
        
        /// <summary>
        /// BACKWARD
        /// </summary>
        BACKWARD = 66,
        
        /// <summary>
        /// CLOCKWISE
        /// </summary>
        CLOCKWISE = 67,
        
        /// <summary>
        /// ANTI_CLOCKWISE
        /// </summary>
        ANTI_CLOCKWISE = 65,
    }
    
    /// <summary>
    /// Basic Stamp2 Operations
    /// </summary>
    [ServicePort()]
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class BasicStamp2Operations : PortSet
    {
        
        /// <summary>
        /// Implicit Operator for Port of Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup>)portSet[typeof(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup)];
        }

        /// <summary>
        /// Implicit Operator for Port of Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop>)portSet[typeof(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop)];
        }

        /// <summary>
        /// Implicit Operator for Port of Get
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<Get>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<Get>)portSet[typeof(Get)];
        }

        /// <summary>
        /// Implicit Operator for Port of Replace
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<Replace>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<Replace>)portSet[typeof(Replace)];
        }

        /// <summary>
        /// Implicit Operator for Port of Subscribe
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<Subscribe>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<Subscribe>)portSet[typeof(Subscribe)];
        }

        /// <summary>
        /// Implicit Operator for Port of QueryConfig
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<QueryConfig>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<QueryConfig>)portSet[typeof(QueryConfig)];
        }

        /// <summary>
        /// Implicit Operator for Port of QueryInfraRed
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<QueryInfraRed>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<QueryInfraRed>)portSet[typeof(QueryInfraRed)];
        }

        /// <summary>
        /// Implicit Operator for Port of QueryMotorSpeed
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<QueryMotorSpeed>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<QueryMotorSpeed>)portSet[typeof(QueryMotorSpeed)];
        }

        /// <summary>
        /// Implicit Operator for Port of UpdateConfig
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<UpdateConfig>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<UpdateConfig>)portSet[typeof(UpdateConfig)];
        }

        /// <summary>
        /// Implicit Operator for Port of UpdateMotorSpeed
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<UpdateMotorSpeed>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<UpdateMotorSpeed>)portSet[typeof(UpdateMotorSpeed)];
        }

        /// <summary>
        /// Implicit Operator for Port of SensorsChanged
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<SensorsChanged>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<SensorsChanged>)portSet[typeof(SensorsChanged)];
        }

        /// <summary>
        /// Implicit Operator for Port of UpdateAutonomousMode
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<UpdateAutonomousMode>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<UpdateAutonomousMode>)portSet[typeof(UpdateAutonomousMode)];
        }

        /// <summary>
        /// Implicit Operator for Port of Microsoft.Dss.Core.DsspHttp.HttpGet
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<Microsoft.Dss.Core.DsspHttp.HttpGet>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<Microsoft.Dss.Core.DsspHttp.HttpGet>)portSet[typeof(Microsoft.Dss.Core.DsspHttp.HttpGet)];
        }

        /// <summary>
        /// Implicit Operator for Port of dssphttp.HttpPost
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<dssphttp.HttpPost>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<dssphttp.HttpPost>)portSet[typeof(dssphttp.HttpPost)];
        }

        /// <summary>
        /// Implicit Operator for Port of SetPins
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<SetPins>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<SetPins>)portSet[typeof(SetPins)];
        }

        /// <summary>
        /// Implicit Operator for Port of PlayTone
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<PlayTone>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<PlayTone>)portSet[typeof(PlayTone)];
        }

        /// <summary>
        /// Implicit Operator for Port of ExecuteBehavior
        /// </summary>
        /// <param name="portSet"></param>
        /// <returns></returns>
        public static implicit operator Port<ExecuteBehavior>(BasicStamp2Operations portSet)
        {
            if (portSet == null) return null;
            return (Port<ExecuteBehavior>)portSet[typeof(ExecuteBehavior)];
        }

        /// <summary>
        /// Post(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(Get)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(Get item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(Replace)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(Replace item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(Subscribe)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(Subscribe item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(QueryConfig)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(QueryConfig item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(QueryInfraRed)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(QueryInfraRed item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(QueryMotorSpeed)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(QueryMotorSpeed item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(UpdateConfig)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(UpdateConfig item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(UpdateMotorSpeed)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(UpdateMotorSpeed item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(SensorsChanged)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(SensorsChanged item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(UpdateAutonomousMode)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(UpdateAutonomousMode item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(dssphttp.HttpGet)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(dssphttp.HttpGet item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(dssphttp.HttpPost)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(dssphttp.HttpPost item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(SetPins)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(SetPins item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(PlayTone)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(PlayTone item) { base.PostUnknownType(item); }

        /// <summary>
        /// Post(ExecuteBehavior)
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public void Post(ExecuteBehavior item) { base.PostUnknownType(item); }

        
        /// <summary>
        /// Basic Stamp2 Operations
        /// </summary>
        public BasicStamp2Operations() : 
                base(typeof(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup), typeof(Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.Get), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.Replace), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.Subscribe), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.QueryConfig), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.QueryInfraRed), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.QueryMotorSpeed), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.UpdateConfig), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.UpdateMotorSpeed), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.SensorsChanged), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.UpdateAutonomousMode), typeof(Microsoft.Dss.Core.DsspHttp.HttpGet), typeof(Microsoft.Dss.Core.DsspHttp.HttpPost), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.SetPins), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.PlayTone), typeof(Microsoft.Robotics.Services.BasicStamp2.Proxy.ExecuteBehavior))
        {
        }
        
        /// <summary>
        /// Required Lookup request body type
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.LookupResponse,Fault> DsspDefaultLookup()
        {
            Microsoft.Dss.ServiceModel.Dssp.LookupRequestType body = new Microsoft.Dss.ServiceModel.Dssp.LookupRequestType();
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Dssp Default Lookup and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.LookupResponse,Fault> DsspDefaultLookup(Microsoft.Dss.ServiceModel.Dssp.LookupRequestType body)
        {
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultLookup();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.LookupRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// A request to drop the service.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultDropResponseType,Fault> DsspDefaultDrop()
        {
            Microsoft.Dss.ServiceModel.Dssp.DropRequestType body = new Microsoft.Dss.ServiceModel.Dssp.DropRequestType();
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Dssp Default Drop and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultDropResponseType,Fault> DsspDefaultDrop(Microsoft.Dss.ServiceModel.Dssp.DropRequestType body)
        {
            Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop op = new Microsoft.Dss.ServiceModel.Dssp.DsspDefaultDrop();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.DropRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Required Get body type
        /// </summary>
        public virtual PortSet<BasicStampState,Fault> Get()
        {
            Microsoft.Dss.ServiceModel.Dssp.GetRequestType body = new Microsoft.Dss.ServiceModel.Dssp.GetRequestType();
            Get op = new Get(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Get and return the response port.
        /// </summary>
        public virtual PortSet<BasicStampState,Fault> Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body)
        {
            Get op = new Get();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.GetRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// The BASIC Stamp 's configuration state.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType,Fault> Replace()
        {
            BasicStampState body = new BasicStampState();
            Replace op = new Replace(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Replace and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType,Fault> Replace(BasicStampState body)
        {
            Replace op = new Replace();
            op.Body = body ?? new BasicStampState();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Subscribe and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,Fault> Subscribe(IPort notificationPort)
        {
            Subscribe op = new Subscribe();
            op.Body = new Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType();
            op.NotificationPort = notificationPort;
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Subscribe and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,Fault> Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body, IPort notificationPort)
        {
            Subscribe op = new Subscribe();
            op.Body = body ?? new Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType();
            op.NotificationPort = notificationPort;
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// The BASIC Stamp 's low level configuration parameters.
        /// </summary>
        public virtual PortSet<Config,Fault> QueryConfig()
        {
            Config body = new Config();
            QueryConfig op = new QueryConfig(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Query Config and return the response port.
        /// </summary>
        public virtual PortSet<Config,Fault> QueryConfig(Config body)
        {
            QueryConfig op = new QueryConfig();
            op.Body = body ?? new Config();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Specifies the state of the BASIC Stamp 's set of sensors.
        /// </summary>
        public virtual PortSet<Sensors,Fault> QueryInfraRed(bool iRLeft, bool iRRight, bool whiskerLeft, bool whiskerRight)
        {
            Sensors body = new Sensors( iRLeft, iRRight, whiskerLeft, whiskerRight);
            QueryInfraRed op = new QueryInfraRed(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Query Infra Red and return the response port.
        /// </summary>
        public virtual PortSet<Sensors,Fault> QueryInfraRed(Sensors body)
        {
            QueryInfraRed op = new QueryInfraRed();
            op.Body = body ?? new Sensors();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Specifies the current left and right motor speed.
        /// </summary>
        public virtual PortSet<MotorSpeed,Fault> QueryMotorSpeed(System.Nullable<System.Double> leftSpeed, System.Nullable<System.Double> rightSpeed)
        {
            MotorSpeed body = new MotorSpeed( leftSpeed, rightSpeed);
            QueryMotorSpeed op = new QueryMotorSpeed(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Query Motor Speed and return the response port.
        /// </summary>
        public virtual PortSet<MotorSpeed,Fault> QueryMotorSpeed(MotorSpeed body)
        {
            QueryMotorSpeed op = new QueryMotorSpeed();
            op.Body = body ?? new MotorSpeed();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// The BASIC Stamp 's low level configuration parameters.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> UpdateConfig()
        {
            Config body = new Config();
            UpdateConfig op = new UpdateConfig(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Update Config and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> UpdateConfig(Config body)
        {
            UpdateConfig op = new UpdateConfig();
            op.Body = body ?? new Config();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Specifies the current left and right motor speed.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> UpdateMotorSpeed(System.Nullable<System.Double> leftSpeed, System.Nullable<System.Double> rightSpeed)
        {
            MotorSpeed body = new MotorSpeed( leftSpeed, rightSpeed);
            UpdateMotorSpeed op = new UpdateMotorSpeed(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Update Motor Speed and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> UpdateMotorSpeed(MotorSpeed body)
        {
            UpdateMotorSpeed op = new UpdateMotorSpeed();
            op.Body = body ?? new MotorSpeed();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Specifies the state of the BASIC Stamp 's set of sensors.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> SensorsChanged(bool iRLeft, bool iRRight, bool whiskerLeft, bool whiskerRight)
        {
            Sensors body = new Sensors( iRLeft, iRRight, whiskerLeft, whiskerRight);
            SensorsChanged op = new SensorsChanged(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Sensors Changed and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> SensorsChanged(Sensors body)
        {
            SensorsChanged op = new SensorsChanged();
            op.Body = body ?? new Sensors();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Specifies if the BASIC Stamp is in autonomous mode or if it is controlled by the PC.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> UpdateAutonomousMode()
        {
            AutonomousMode body = new AutonomousMode();
            UpdateAutonomousMode op = new UpdateAutonomousMode(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Update Autonomous Mode and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> UpdateAutonomousMode(AutonomousMode body)
        {
            UpdateAutonomousMode op = new UpdateAutonomousMode();
            op.Body = body ?? new AutonomousMode();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// DsspHttp Get request body
        /// </summary>
        public virtual PortSet<Microsoft.Dss.Core.DsspHttp.HttpResponseType,Fault> HttpGet()
        {
            dssphttp.HttpGetRequestType body = new dssphttp.HttpGetRequestType();
            Microsoft.Dss.Core.DsspHttp.HttpGet op = new Microsoft.Dss.Core.DsspHttp.HttpGet(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Http Get and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.Core.DsspHttp.HttpResponseType,Fault> HttpGet(dssphttp.HttpGetRequestType body)
        {
            Microsoft.Dss.Core.DsspHttp.HttpGet op = new Microsoft.Dss.Core.DsspHttp.HttpGet();
            op.Body = body ?? new dssphttp.HttpGetRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// DsspHttp Post request body
        /// </summary>
        public virtual PortSet<dssphttp.HttpResponseType,Fault> HttpPost()
        {
            dssphttp.HttpPostRequestType body = new dssphttp.HttpPostRequestType();
            dssphttp.HttpPost op = new dssphttp.HttpPost(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Http Post and return the response port.
        /// </summary>
        public virtual PortSet<dssphttp.HttpResponseType,Fault> HttpPost(dssphttp.HttpPostRequestType body)
        {
            dssphttp.HttpPost op = new dssphttp.HttpPost();
            op.Body = body ?? new dssphttp.HttpPostRequestType();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Specifies settings for up to two I/O pins.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> SetPins(byte pin1, byte op1, byte pin2, byte op2)
        {
            Pins body = new Pins( pin1, op1, pin2, op2);
            SetPins op = new SetPins(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Set Pins and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> SetPins(Pins body)
        {
            SetPins op = new SetPins();
            op.Body = body ?? new Pins();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Sound a Tone on the Speaker.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> PlayTone(int frequency, int duration)
        {
            Tone body = new Tone( frequency, duration);
            PlayTone op = new PlayTone(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Play Tone and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> PlayTone(Tone body)
        {
            PlayTone op = new PlayTone();
            op.Body = body ?? new Tone();
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Execute pre -defined Behavior (in firmware).
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ExecuteBehavior(char code, int duration)
        {
            Behavior body = new Behavior( code, duration);
            ExecuteBehavior op = new ExecuteBehavior(body);
            this.Post(op);
            return op.ResponsePort;

        }
        
        /// <summary>
        /// Post Execute Behavior and return the response port.
        /// </summary>
        public virtual PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,Fault> ExecuteBehavior(Behavior body)
        {
            ExecuteBehavior op = new ExecuteBehavior();
            op.Body = body ?? new Behavior();
            this.Post(op);
            return op.ResponsePort;

        }
    }
    
    /// <summary>
    /// Gets the Boe- Bot 's current state.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("Get")]
    [Description("Gets the Boe-Bot\'s current state.")]
    public class Get : Microsoft.Dss.ServiceModel.Dssp.Get<Microsoft.Dss.ServiceModel.Dssp.GetRequestType, PortSet<BasicStampState, Fault>>
    {
        
        /// <summary>
        /// Gets the Boe- Bot 's current state.
        /// </summary>
        public Get()
        {
        }
        
        /// <summary>
        /// Gets the Boe- Bot 's current state.
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Gets the Boe- Bot 's current state.
        /// </summary>
        public Get(Microsoft.Dss.ServiceModel.Dssp.GetRequestType body, Microsoft.Ccr.Core.PortSet<BasicStampState,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Changes (or indicates a change to) the Boe- Bot 's entire state.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("ChangeState")]
    [Description("Changes (or indicates a change to) the Boe-Bot\'s entire state.")]
    public class Replace : Microsoft.Dss.ServiceModel.Dssp.Replace<BasicStampState, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType, Fault>>
    {
        
        /// <summary>
        /// Changes (or indicates a change to) the Boe- Bot 's entire state.
        /// </summary>
        public Replace()
        {
        }
        
        /// <summary>
        /// Changes (or indicates a change to) the Boe- Bot 's entire state.
        /// </summary>
        public Replace(BasicStampState body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Changes (or indicates a change to) the Boe- Bot 's entire state.
        /// </summary>
        public Replace(BasicStampState body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultReplaceResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Subscribe
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    public class Subscribe : Microsoft.Dss.ServiceModel.Dssp.Subscribe<Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType, PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType, Fault>>
    {
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe()
        {
        }
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Subscribe
        /// </summary>
        public Subscribe(Microsoft.Dss.ServiceModel.Dssp.SubscribeRequestType body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.SubscribeResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Gets the Boe- Bot 's current configuration.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("GetConfiguration")]
    [Description("Gets the Boe-Bot\'s current configuration.")]
    public class QueryConfig : Microsoft.Dss.ServiceModel.Dssp.Query<Config, PortSet<Config, Fault>>
    {
        
        /// <summary>
        /// Gets the Boe- Bot 's current configuration.
        /// </summary>
        public QueryConfig()
        {
        }
        
        /// <summary>
        /// Gets the Boe- Bot 's current configuration.
        /// </summary>
        public QueryConfig(Config body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Gets the Boe- Bot 's current configuration.
        /// </summary>
        public QueryConfig(Config body, Microsoft.Ccr.Core.PortSet<Config,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Gets the infrared and whisker sensors' state.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("GetSensors")]
    [Description("Gets the infrared and whisker sensors\' state.")]
    public class QueryInfraRed : Microsoft.Dss.ServiceModel.Dssp.Query<Sensors, PortSet<Sensors, Fault>>
    {
        
        /// <summary>
        /// Gets the infrared and whisker sensors' state.
        /// </summary>
        public QueryInfraRed()
        {
        }
        
        /// <summary>
        /// Gets the infrared and whisker sensors' state.
        /// </summary>
        public QueryInfraRed(Sensors body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Gets the infrared and whisker sensors' state.
        /// </summary>
        public QueryInfraRed(Sensors body, Microsoft.Ccr.Core.PortSet<Sensors,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Gets the motor speed.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("GetMotorSpeed")]
    [Description("Gets the motor speed.")]
    public class QueryMotorSpeed : Microsoft.Dss.ServiceModel.Dssp.Query<MotorSpeed, PortSet<MotorSpeed, Fault>>
    {
        
        /// <summary>
        /// Gets the motor speed.
        /// </summary>
        public QueryMotorSpeed()
        {
        }
        
        /// <summary>
        /// Gets the motor speed.
        /// </summary>
        public QueryMotorSpeed(MotorSpeed body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Gets the motor speed.
        /// </summary>
        public QueryMotorSpeed(MotorSpeed body, Microsoft.Ccr.Core.PortSet<MotorSpeed,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Updates (or indicates an update to) the Boe- Bot 's configuration.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("UpdateConfiguration")]
    [Description("Updates (or indicates an update to) the Boe-Bot\'s configuration.")]
    public class UpdateConfig : Microsoft.Dss.ServiceModel.Dssp.Update<Config, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Updates (or indicates an update to) the Boe- Bot 's configuration.
        /// </summary>
        public UpdateConfig()
        {
        }
        
        /// <summary>
        /// Updates (or indicates an update to) the Boe- Bot 's configuration.
        /// </summary>
        public UpdateConfig(Config body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Updates (or indicates an update to) the Boe- Bot 's configuration.
        /// </summary>
        public UpdateConfig(Config body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Updates (or indicates an update to) motor speed.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("UpdateSpeed")]
    [Description("Updates (or indicates an update to) motor speed.")]
    public class UpdateMotorSpeed : Microsoft.Dss.ServiceModel.Dssp.Update<MotorSpeed, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Updates (or indicates an update to) motor speed.
        /// </summary>
        public UpdateMotorSpeed()
        {
        }
        
        /// <summary>
        /// Updates (or indicates an update to) motor speed.
        /// </summary>
        public UpdateMotorSpeed(MotorSpeed body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Updates (or indicates an update to) motor speed.
        /// </summary>
        public UpdateMotorSpeed(MotorSpeed body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Indicates one or more of the Boe- Bot 's whiskers or infrared sensors have changed.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("SensorsChanged")]
    [Description("Indicates one or more of the Boe-Bot\'s whiskers or infrared sensors have changed." +
        "")]
    public class SensorsChanged : Microsoft.Dss.ServiceModel.Dssp.Update<Sensors, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Indicates one or more of the Boe- Bot 's whiskers or infrared sensors have changed.
        /// </summary>
        public SensorsChanged()
        {
        }
        
        /// <summary>
        /// Indicates one or more of the Boe- Bot 's whiskers or infrared sensors have changed.
        /// </summary>
        public SensorsChanged(Sensors body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Indicates one or more of the Boe- Bot 's whiskers or infrared sensors have changed.
        /// </summary>
        public SensorsChanged(Sensors body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Updates (or indicates an update to) the Boe- Bot 's autonomous state.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("UpdateAutonomousMode")]
    [Description("Updates (or indicates an update to) the Boe-Bot\'s autonomous state.")]
    public class UpdateAutonomousMode : Microsoft.Dss.ServiceModel.Dssp.Update<AutonomousMode, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Updates (or indicates an update to) the Boe- Bot 's autonomous state.
        /// </summary>
        public UpdateAutonomousMode()
        {
        }
        
        /// <summary>
        /// Updates (or indicates an update to) the Boe- Bot 's autonomous state.
        /// </summary>
        public UpdateAutonomousMode(AutonomousMode body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Updates (or indicates an update to) the Boe- Bot 's autonomous state.
        /// </summary>
        public UpdateAutonomousMode(AutonomousMode body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Sets Digital I/O Pins on the Boe- Bot.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("SetPins")]
    [Description("Sets Digital I/O Pins on the Boe-Bot.")]
    public class SetPins : Microsoft.Dss.ServiceModel.Dssp.Update<Pins, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Sets Digital I/O Pins on the Boe- Bot.
        /// </summary>
        public SetPins()
        {
        }
        
        /// <summary>
        /// Sets Digital I/O Pins on the Boe- Bot.
        /// </summary>
        public SetPins(Pins body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Sets Digital I/O Pins on the Boe- Bot.
        /// </summary>
        public SetPins(Pins body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Plays a tone on the speaker on the Boe- Bot.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("PlayTone")]
    [Description("Plays a tone on the speaker on the Boe-Bot.")]
    public class PlayTone : Microsoft.Dss.ServiceModel.Dssp.Update<Tone, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Plays a tone on the speaker on the Boe- Bot.
        /// </summary>
        public PlayTone()
        {
        }
        
        /// <summary>
        /// Plays a tone on the speaker on the Boe- Bot.
        /// </summary>
        public PlayTone(Tone body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Plays a tone on the speaker on the Boe- Bot.
        /// </summary>
        public PlayTone(Tone body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
    
    /// <summary>
    /// Executes a firmware behavior on the Boe- Bot.
    /// </summary>
    [XmlTypeAttribute(IncludeInSchema=false)]
    [DisplayName("ExecuteBehavior")]
    [Description("Executes a firmware behavior on the Boe-Bot.")]
    public class ExecuteBehavior : Microsoft.Dss.ServiceModel.Dssp.Update<Behavior, PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType, Fault>>
    {
        
        /// <summary>
        /// Executes a firmware behavior on the Boe- Bot.
        /// </summary>
        public ExecuteBehavior()
        {
        }
        
        /// <summary>
        /// Executes a firmware behavior on the Boe- Bot.
        /// </summary>
        public ExecuteBehavior(Behavior body) : 
                base(body)
        {
        }
        
        /// <summary>
        /// Executes a firmware behavior on the Boe- Bot.
        /// </summary>
        public ExecuteBehavior(Behavior body, Microsoft.Ccr.Core.PortSet<Microsoft.Dss.ServiceModel.Dssp.DefaultUpdateResponseType,W3C.Soap.Fault> responsePort) : 
                base(body, responsePort)
        {
        }
    }
}
